'From Squeak4.1 of 20 May 2010 [latest update: #10154] on 25 May 2010 at 7:25:19 am'!
Object subclass: #WeakFinalizationList
	instanceVariableNames: 'first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Weak'!
!WeakFinalizationList commentStamp: 'Igor.Stasenko 3/8/2010 21:50' prior: 0!
IMPORTANT!!!!!!

This class is a special object, recognized by VM.
Its only purpose is to 
a) identify a special kind of objects who usually having a weak references but
  also having an instance of me held by first non-weak fixed slot (instance variable).

b) a 'first' instance variable points to the head of a list of items, reported by VM which has weak references which became garbage during last garbage collection!


!WeakFinalizationList methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 20:40'!
first
	^ first! !

!WeakFinalizationList methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 22:28'!
swapWithNil

	| head |
	head := first.
	first := nil.
	^ head! !
