'From Squeak4.1 of 20 May 2010 [latest update: #10154] on 25 May 2010 at 7:25:24 am'!
Object weakSubclass: #WeakFinalizerItem
	instanceVariableNames: 'list next executor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Weak'!

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/25/2010 06:02'!
add: newExecutor

	executor 
		ifNil: [ executor := newExecutor ]
		ifNotNil: [
			executor hasMultipleExecutors
				ifTrue: [ executor add: newExecutor]
				ifFalse: [ executor := ObjectFinalizerCollection with: executor with: newExecutor ]
		]! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 22:57'!
clear
	list := next := nil.! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 21:01'!
executor
	^ executor! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 20:51'!
list
	^ list! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 23:14'!
list: aList
	list := aList! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 21:05'!
next
	^ next! !

!WeakFinalizerItem methodsFor: 'accessing' stamp: 'Igor.Stasenko 3/8/2010 21:01'!
object
	^ self at: 1! !


!WeakFinalizerItem methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/25/2010 05:29'!
list: weakFinalizationList object: anObject
	self assert: (weakFinalizationList class == WeakFinalizationList).
	list := weakFinalizationList.
	self at: 1 put: anObject.
! !

!WeakFinalizerItem methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 3/8/2010 21:02'!
list: weakFinalizationList object: anObject executor: anExecutor
	self assert: (weakFinalizationList class == WeakFinalizationList).
	list := weakFinalizationList.
	self at: 1 put: anObject.
	executor := anExecutor! !


!WeakFinalizerItem methodsFor: 'copying' stamp: 'Igor.Stasenko 3/8/2010 23:14'!
copyWithList: aList

	^ self copy list: aList! !

!WeakFinalizerItem methodsFor: 'copying' stamp: 'Igor.Stasenko 5/25/2010 05:33'!
postCopy
	executor hasMultipleFinalizers ifTrue: [ executor := executor copy ].! !


!WeakFinalizerItem methodsFor: 'finalizing' stamp: 'Igor.Stasenko 5/25/2010 05:39'!
finalizeValues
	" cleanup the receiver, so it could be reused "
	| ex |
	ex := executor.
	executor := nil.
	next := nil.
	ex finalize.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WeakFinalizerItem class
	instanceVariableNames: ''!

!WeakFinalizerItem class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 3/8/2010 21:00'!
new
	^ self basicNew: 1! !
